<template>
    <div class='portlet app-ctrl-list-view ' :style="{'height': isAdaptiveSize ? 'calc(100% - 16px)' : getHeight,}">
        <p class='portlet-title'>
            <span>
            
            部件列表
            </span>
            <span class="portlet-action">
                <a @click="uiAction('u6920b81', $event)" v-show="uiactionModel['more'].visabled" :disabled="uiactionModel['more'].disabled">
                  <span>MORE</span>
                </a>
            </span>
        </p>
        <el-divider class="divider"></el-divider>
        <div class="portlet-with-title">
        <ibizappctrllist-view :portletState="viewState" :viewdata="JSON.stringify(context)" :viewDefaultUsage="false" ></ibizappctrllist-view>
        </div>
    </div>
</template>
// 基于 @CONTROL/门户部件/CONTROL-BASE.vue.ftl 生成
<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util, ViewTool } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import IBIZAPPCTRLService from '@/service/ibizappctrl/ibizappctrl-service';
import AppCtrlListViewService from './app-ctrl-list-view-portlet-service';

import IBIZAPPCTRLUIService from '@/uiservice/ibizappctrl/ibizappctrl-ui-service';
import UIService from '@/uiservice/ui-service';
import { Environment } from '@/environments/environment';


@Component({
    components: {
      
    }
})
export default class IBIZAPPCTRLAppCtrlListViewBase extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof AppCtrlListViewBase
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof AppCtrlListViewBase
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof AppCtrlListViewBase
     */
    @Prop() public context!: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof AppCtrlListViewBase
     */
    @Prop() public viewparams!: any;

    /**
     * 视图操作参数
     *
     * @type {*}
     * @memberof AppCtrlListViewBase
     */
    @Prop() public viewCtx!: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof AppCtrlListViewBase
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof AppCtrlListViewBase
     */
    public getControlType(): string {
        return 'PORTLET'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof AppCtrlListViewBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {AppCtrlListViewService}
     * @memberof AppCtrlListViewBase
     */
    public service: AppCtrlListViewService = new AppCtrlListViewService({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {IBIZAPPCTRLService}
     * @memberof AppCtrlListViewBase
     */
    public appEntityService: IBIZAPPCTRLService = new IBIZAPPCTRLService({ $store: this.$store });

    /**
     * 界面UI服务对象
     *
     * @type {IBIZAPPCTRLUIService}
     * @memberof AppCtrlListViewBase
     */  
    public appUIService:IBIZAPPCTRLUIService = new IBIZAPPCTRLUIService();
    

    /**
     * 逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @param {*} [$event]
     * @memberof 
     */
    public db_sysportlet8_u6920b81_click(params: any = {}, tag?: any, $event?: any) {
        // 取数
        let datas: any[] = [];
        let xData: any = null;
        // _this 指向容器对象
        const _this: any = this;
        let paramJO:any = {};
        let contextJO:any = {};
        xData = this;
        if (_this.getDatas && _this.getDatas instanceof Function) {
            datas = [..._this.getDatas()];
        }
        if(params){
          datas = [params];
        }
        // 界面行为
        const curUIService:IBIZAPPCTRLUIService  = new IBIZAPPCTRLUIService();
        curUIService.IBIZAPPCTRL_MORE(datas,contextJO, paramJO,  $event, xData,this,"IBIZAPPCTRL");
    }


    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof AppCtrlListViewBase
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof AppCtrlListViewBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }



    /**
     * 长度
     *
     * @type {number}
     * @memberof AppCtrlListViewBase
     */
    @Prop() public height?: number;

    /**
     * 宽度
     *
     * @type {number}
     * @memberof AppCtrlListViewBase
     */
    @Prop() public width?: number;

    /**
     * 门户部件类型
     *
     * @type {string}
     * @memberof AppCtrlListViewBase
     */
    public portletType: string = 'view';

    /**
     * 部件类型
     *
     * @type {string}
     * @memberof AppCtrlListViewBase
     */
    public controlType: string = 'PORTLET';

    /**
     * 视图默认使用
     *
     * @type {string}
     * @memberof AppCtrlListViewBase
     */
    @Inject({from:'navModel',default: 'tab'})
    public navModel!:string;


    /**
     * 界面行为模型数据
     *
     * @memberof AppCtrlListViewBase
     */
    public uiactionModel: any = {
        more: {name: 'more', actiontarget: 'NONE', caption: '', disabled: false, type: 'DEUIACTION', visabled: true, noprivdisplaymode: 2, dataaccaction: '', uiaction: { tag: 'MORE', target: 'NONE' } },
    }


    /**
     * 是否自适应大小
     *
     * @returns {boolean}
     * @memberof AppCtrlListViewBase
     */
    @Prop({default: false})public isAdaptiveSize!: boolean;

    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof AppCtrlListViewBase
     */
    public getDatas(): any[] {
        return [];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof AppCtrlListViewBase
     */
    public getData(): any {
        return {};
    }

    /**
     * 获取高度
     *
     * @returns {any[]}
     * @memberof AppCtrlListViewBase
     */
    get getHeight(){
        if(!this.$util.isEmpty(this.height) && !this.$util.isNumberNaN(this.height)){
            if(this.height == 0){
                return 'auto';
            }else{
                return this.height+'px';
            }
        }else{
            return '400px';
        }
    }

    /**
     * 刷新
     *
     * @memberof AppCtrlListViewBase
     */
    public refresh(args?: any) {
      this.viewState.next({ tag: 'IBIZAPPCTRLListView', action: 'refresh', data: args });
    }

    /**
     * vue 生命周期
     *
     * @memberof AppCtrlListViewBase
     */
    public created() {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof AppCtrlListViewBase
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if(Object.is(tag, "all-portlet") && Object.is(action,'loadmodel')){
                   this.calcUIActionAuthState(data);
                }
                if (!Object.is(tag, this.name)) {
                    return;
                }
                const refs: any = this.$refs;
                Object.keys(refs).forEach((_name: string) => {
                    this.viewState.next({ tag: _name, action: action, data: data });
                });
            });
        }
    }

    /**
     * vue 生命周期
     *
     * @memberof AppCtrlListViewBase
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof AppCtrlListViewBase
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
    }

    /**
     * 执行界面行为
     *
     * @memberof AppCtrlListViewBase
     */
    public uiAction(tag:string,event:any){
        if(Object.is(tag,'u6920b81')){
            this.db_sysportlet8_u6920b81_click(null,tag,event);
        }
    }

    /**
     * 计算界面行为权限
     *
     * @memberof AppCtrlListViewBase
     */
    public calcUIActionAuthState(data:any = {}) {
        //  如果是操作栏，不计算权限
        if(this.portletType && Object.is('actionbar', this.portletType)) {
            return;
        }
        let _this: any = this;
        let uiservice: any = _this.appUIService ? _this.appUIService : new UIService();
        if(_this.uiactionModel){
            ViewTool.calcActionItemAuthState(data,_this.uiactionModel,uiservice);
        }
    }

}
</script>

<style lang='scss'>
@import './app-ctrl-list-view-portlet.scss';
</style>

